=== modified file 'NEWS'
--- NEWS	2007-08-14 19:27:04 +0000
+++ NEWS	2007-08-14 19:57:48 +0000
@@ -3,6 +3,7 @@
 * BzrTools does not do out-of-date checks unless a bzrtools command is run
 * shelf doesn't emit reject message in test suite
 * branches now works with Apache (and possibly other servers) again
+* branches now dies quickly & cleanly if it can't connect
 * multi-pull reuses connections where possible
 
 July 10 2007

=== modified file 'bzrtools.py'
--- bzrtools.py	2007-08-14 19:25:30 +0000
+++ bzrtools.py	2007-08-14 19:57:48 +0000
@@ -28,7 +28,7 @@
 import bzrlib.errors
 from bzrlib.errors import (BzrCommandError, NotBranchError, NoSuchFile,
                            UnsupportedFormatError, TransportError,
-                           NoWorkingTree, PermissionDenied)
+                           NoWorkingTree, PermissionDenied, ConnectionError)
 from bzrlib.bzrdir import BzrDir, BzrDirFormat
 from bzrlib.transport import get_transport
 
@@ -342,6 +342,8 @@
     try:
         bzrdir = bzrdir_from_transport(t)
         yield bzrdir
+    except (ConnectionError):
+        raise
     except (NotBranchError, UnsupportedFormatError, TransportError,
             PermissionDenied):
         pass

